signature CDOCS = sig

  datatype cdoc =
    Txt of Context.ctxt * string
  | Ws  of Context.ctxt * string
  | Nd  of Context.ctxt * SMLNG.tag * cdocs
  and cdocs = One of cdoc | App of cdocs * cdocs

  val ctxt : cdoc -> Context.ctxt
  val tag  : cdoc -> SMLNG.tag option

  val fold : {kOne:'a -> 'b,
	      kCons:('a * 'b) -> 'b,
	      kTxt:(Context.ctxt * string) -> 'a,
	      kWs:(Context.ctxt * string) -> 'a,
	      kNd:(Context.ctxt * SMLNG.tag * 'b) -> 'a} -> cdocs -> 'b

  val fromDoc : SMLNG.doc -> cdocs
  val toDoc : cdocs -> SMLNG.doc
end
