signature EM_ELIMINATION = sig
  val go : SMLNG.doc -> SMLNG.doc 
end
structure EMElimination :> EM_ELIMINATION =
  struct
    structure T = SMLNG
    structure C = Context
    fun go doc = let
      fun kSeq(x,y) = T.Seq(x,y)
      fun kTxt(c,s) = T.Txt s
      fun kWs(c,s) = T.Ws s
      fun kNd(c,T.EM,d) =
	if (Context.isSet(T.S,c) orelse Context.isSet(T.EM,c)) then d
	else T.Nd(T.EM,d)
       |  kNd(c,t,d)= T.Nd(t,d)
	    
    in Context.fold_with_ctxt {kSeq=kSeq,
			       kTxt=kTxt,
			       kWs=kWs,
			       kNd=kNd}
       Context.init doc
    end
  end
